#include "chdecl.h"
void CH_chcode_chdictionary_proglit(current, sched, cop)
#define ARGUMENTS 4
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto c20;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* new_record 4 , 5 */
  if ((ch_val.record = new_record(5)) == nil) goto ch_depletion;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val; REF(4).tsdr = & dr_record;
/* copy 4.0 3.0.0 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(4)DOT(0).tsdr)->finalize)(REF(4)DOT(0).value,F_DISCARD,sched);
  REF(4)DOT(0).value = ch_val;
  REF(4)DOT(0).tsdr = datarepmap[REF(3)DOT(0)DOT(0).tsdr->number];
/* copy 4.1 3.0.1 */
  if((ch_returncode = (REF(3)DOT(0)DOT(1).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(1).value)) != Normal) goto ch_raise_exception;
  (*(REF(4)DOT(1).tsdr)->finalize)(REF(4)DOT(1).value,F_DISCARD,sched);
  REF(4)DOT(1).value = ch_val;
  REF(4)DOT(1).tsdr = datarepmap[REF(3)DOT(0)DOT(1).tsdr->number];
/* ilit 4.2 , 0 */
  REF(4)DOT(2).value.integer = 0;
  REF(4)DOT(2).tsdr = & dr_integer;
/* move 4.3 3.1 */
  (*(REF(4)DOT(3).tsdr)->finalize)(REF(4)DOT(3).value,F_DISCARD,sched);
  REF(4)DOT(3) = REF(3)DOT(1);
  REF(3)DOT(1).tsdr = & dr_bottom;
/* unite 4.4 5 , 4 */
  if ((ch_returncode = che_unite(DEF(4)DOT(4),DEF(5),sched,4)) != Normal)
     goto ch_raise_exception;
/* new_record 6 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).value = ch_val; REF(6).tsdr = & dr_record;
/* copy 6.0 4.0 */
  if((ch_returncode = (REF(4)DOT(0).tsdr->copy)(& ch_val, REF(4)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(6)DOT(0).tsdr)->finalize)(REF(6)DOT(0).value,F_DISCARD,sched);
  REF(6)DOT(0).value = ch_val;
  REF(6)DOT(0).tsdr = datarepmap[REF(4)DOT(0).tsdr->number];
/* size 6.1 3.0.2 */
  REF(6)DOT(1).value.integer = REF(3)DOT(0)DOT(2).value.table->size;
  REF(6)DOT(1).tsdr = & dr_integer;
/* copy 3.0.3 6.1 */
  REF(3)DOT(0)DOT(3) = REF(6)DOT(1);
/* insert 3.2 6 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(6),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* insert 3.0.2 4 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(0)DOT(2),DEF(4)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c20:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
